diff -urN ../VisualBoyAdvance-1.7.2/src/arm-new.h ./src/arm-new.h
--- ../VisualBoyAdvance-1.7.2/src/arm-new.h	2004-05-13 22:57:11 +0900
+++ ./src/arm-new.h	2006-08-25 22:30:08 +0900
@@ -4741,7 +5806,8 @@
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address - value;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x6c0:
@@ -4751,13 +5817,16 @@
   case 0x6e8:
     {
       // STRB Rd, [Rn], Rm, LSL #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address + offset;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x6c2:
@@ -4767,6 +5836,8 @@
   case 0x6ea:
     {
       // STRB Rd, [Rn], Rm, LSR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -4774,7 +5845,8 @@
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address + offset;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x6c4:
@@ -4783,7 +5855,9 @@
   case 0x6e4:
   case 0x6ec:
     {
-      // STR Rd, [Rn], Rm, ASR #
+      // STRB Rd, [Rn], Rm, ASR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4797,7 +5871,8 @@
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address + offset;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x6c6:
@@ -4807,6 +5882,8 @@
   case 0x6ee:
     {
       // STRB Rd, [Rn], Rm, ROR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4819,38 +5896,47 @@
       u32 address = reg[base].I;
       CPUWriteByte(address, reg[dest].B.B0);
       reg[base].I = address + value;
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x740:
   case 0x748:
     {
       // STRB Rd, [Rn, -Rm, LSL #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x742:
   case 0x74a:
     {
       // STRB Rd, [Rn, -Rm, LSR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x744:
   case 0x74c:
     {
       // STRB Rd, [Rn, -Rm, ASR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4863,13 +5949,16 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x746:
   case 0x74e:
     {
       // STRB Rd, [Rn, -Rm, ROR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4881,26 +5970,32 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - value;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x760:
   case 0x768:
     {
       // STRB Rd, [Rn, -Rm, LSL #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[base].I = address;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x762:
   case 0x76a:
     {
       // STRB Rd, [Rn, -Rm, LSR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -4908,13 +6003,16 @@
       u32 address = reg[base].I - offset;
       reg[base].I = address;      
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x764:
   case 0x76c:
     {
       // STRB Rd, [Rn, -Rm, ASR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4928,13 +6026,16 @@
       u32 address = reg[base].I - offset;
       reg[base].I = address;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x766:
   case 0x76e:
     {
       // STRB Rd, [Rn, -Rm, ROR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -4947,38 +6048,47 @@
       u32 address = reg[base].I - value;
       reg[base].I = address;      
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7c0:
   case 0x7c8:
     {
       // STRB Rd, [Rn, Rm, LSL #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7c2:
   case 0x7ca:
     {
       // STRB Rd, [Rn, Rm, LSR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7c4:
   case 0x7cc:
     {
       // STRB Rd, [Rn, Rm, ASR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -4991,13 +6101,16 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7c6:
   case 0x7ce:
     {
       // STRB Rd, [Rn, Rm, ROR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -5009,26 +6122,32 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + value;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7e0:
   case 0x7e8:
     {
       // STRB Rd, [Rn, Rm, LSL #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[base].I = address;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7e2:
   case 0x7ea:
     {
       // STRB Rd, [Rn, Rm, LSR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -5036,13 +6155,16 @@
       u32 address = reg[base].I + offset;
       reg[base].I = address;      
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7e4:
   case 0x7ec:
     {
       // STRB Rd, [Rn, Rm, ASR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -5056,13 +6178,16 @@
       u32 address = reg[base].I + offset;
       reg[base].I = address;
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7e6:
   case 0x7ee:
     {
       // STRB Rd, [Rn, Rm, ROR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -5075,7 +6200,8 @@
       u32 address = reg[base].I + value;
       reg[base].I = address;      
       CPUWriteByte(address, reg[dest].B.B0);
-      clockTicks += 2 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x650:
@@ -5085,6 +6211,8 @@
   case 0x678:
     {
       // LDRB Rd, [Rn], -Rm, LSL #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -5092,7 +6220,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address - offset;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x652:
@@ -5102,6 +6239,8 @@
   case 0x67a:
     {
       // LDRB Rd, [Rn], -Rm, LSR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -5110,7 +6249,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address - offset;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x654:
@@ -5120,6 +6268,8 @@
   case 0x67c:
     {
       // LDRB Rd, [Rn], -Rm, ASR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -5134,7 +6284,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address - offset;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x656:
@@ -5144,6 +6303,8 @@
   case 0x67e:
     {
       // LDRB Rd, [Rn], -Rm, ROR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -5157,7 +6318,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address - value;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x6d0:
@@ -5167,6 +6337,8 @@
   case 0x6f8:
     {
       // LDRB Rd, [Rn], Rm, LSL #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -5174,7 +6346,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address + offset;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x6d2:
@@ -5184,6 +6365,8 @@
   case 0x6fa:
     {
       // LDRB Rd, [Rn], Rm, LSR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -5192,7 +6375,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address + offset;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x6d4:
@@ -5202,6 +6394,8 @@
   case 0x6fc:
     {
       // LDRB Rd, [Rn], Rm, ASR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -5216,7 +6410,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address + offset;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x6d6:
@@ -5226,6 +6429,8 @@
   case 0x6fe:
     {
       // LDRB Rd, [Rn], Rm, ROR #
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -5239,38 +6444,71 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address + value;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x750:
   case 0x758:
     {
       // LDRB Rd, [Rn, -Rm, LSL #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x752:
   case 0x75a:
     {
       // LDRB Rd, [Rn, -Rm, LSR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x754:
   case 0x75c:
     {
       // LDRB Rd, [Rn, -Rm, ASR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -5283,13 +6521,24 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - offset;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x756:
   case 0x75e:
     {
       // LDRB Rd, [Rn, -Rm, ROR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -5301,13 +6550,24 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I - value;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x770:
   case 0x778:
     {
       // LDRB Rd, [Rn, -Rm, LSL #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -5315,13 +6575,24 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x772:
   case 0x77a:
     {
       // LDRB Rd, [Rn, -Rm, LSR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -5330,13 +6601,24 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;      
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x774:
   case 0x77c:
     {
       // LDRB Rd, [Rn, -Rm, ASR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -5351,13 +6633,24 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x776:
   case 0x77e:
     {
       // LDRB Rd, [Rn, -Rm, ROR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -5371,38 +6664,71 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;      
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7d0:
   case 0x7d8:
     {
       // LDRB Rd, [Rn, Rm, LSL #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7d2:
   case 0x7da:
     {
       // LDRB Rd, [Rn, Rm, LSR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7d4:
   case 0x7dc:
     {
       // LDRB Rd, [Rn, Rm, ASR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -5415,13 +6741,24 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + offset;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7d6:
   case 0x7de:
     {
       // LDRB Rd, [Rn, Rm, ROR #]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -5433,13 +6770,24 @@
       int base = (opcode >> 16) & 15;
       u32 address = reg[base].I + value;
       reg[dest].I = CPUReadByte(address);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7f0:
   case 0x7f8:
     {
       // LDRB Rd, [Rn, Rm, LSL #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int offset = reg[opcode & 15].I << ((opcode>>7)& 31);
       int dest = (opcode >> 12) & 15;
       int base = (opcode >> 16) & 15;
@@ -5447,13 +6795,24 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7f2:
   case 0x7fa:
     {
       // LDRB Rd, [Rn, Rm, LSR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset = shift ? reg[opcode & 15].I >> shift : 0;
       int dest = (opcode >> 12) & 15;
@@ -5462,13 +6821,24 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;      
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7f4:
   case 0x7fc:
     {
       // LDRB Rd, [Rn, Rm, ASR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       int offset;
       if(shift)
@@ -5483,13 +6853,24 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x7f6:
   case 0x7fe:
     {
       // LDRB Rd, [Rn, Rm, ROR #]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int shift = (opcode >> 7) & 31;
       u32 value = reg[opcode & 15].I;
       if(shift) {
@@ -5503,7 +6884,16 @@
       reg[dest].I = CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;      
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
 #define STMW_REG(val,num) \
